#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


#include "contactnetwork.hh"

template <class GridType, int dim>
void ContactNetwork<GridType, dim>::assemble() {
    for (size_t i=0; i<levelContactNetworks_.size(); i++) {
        levelContactNetworks_[i]->assemble();
    }
}

template <class GridType, int dim>
void ContactNetwork<GridType, dim>::addLevelContactNetwork(std::shared_ptr<LevelContactNetwork> levelContactNetwork) {
    size_t level = levelContactNetwork->level();
    assert(level < this->size());

    levelContactNetworks_[level] = levelContactNetwork;
}

template <class GridType, int dim>
const std::shared_ptr<typename ContactNetwork<GridType, dim>::LevelContactNetwork>& ContactNetwork<GridType, dim>::addLevelContactNetwork(int nBodies, int nCouplings, int level) {
    assert(level < this->size());

    levelContactNetworks_[level] = std::make_shared<LevelContactNetwork>(nBodies, nCouplings, level);
    return levelContactNetworks_[level];
}

#include "contactnetwork_tmpl.cc"
